跳至主要內容
API 參考
API 參考

Suno 替換段落

使用替換區段端點以建立非同步任務。

01

概覽

使用替換區段端點配合受支援的模型。使用返回的任務 ID 來檢索其狀態,或提供 callback_url 以接收以下記錄的推送通知。

快速入門

  1. 建立 API 金鑰並將其設定為 RUNAPI_API_KEY。
  2. 選擇支援的模型,並發送主體符合該模型結構的 POST 請求。
  3. 儲存返回的任務 ID,然後輪詢直至達到終止狀態,或處理下方說明的回呼。

端點

POST /api/v1/suno/replace_section
基礎 URL
https://runapi.ai
API 版本
v1
身份驗證
Authorization: Bearer YOUR_API_TOKEN
02

支援的模型

開啟模型頁面以查看當前定價、速率限制及商業用途詳情。

03

請求結構

JSON 內容

欄位及允許的值取決於所選模型。提供後,callback_url 將接收以下記錄的 Task 交付內容。

請求主體12 個欄位
audio_idstring
選填

來源任務中的音頻 ID。與 task_id 搭配使用;請勿與 upload_url/model 組合使用。

callback_urlstring
選填

用於非同步通知的 Webhook URL。

full_lyricsstring
必填

用於上下文的完整歌詞。

邊界值: 5000
infill_end_timenumber
必填

段落結束時間(秒);必須大於 infill_start_time,且替換時長至少為 10 秒。

infill_start_timenumber
必填

段落開始時間(秒);替換時長至少為 10 秒。

lyricsstring
必填

替換用的區段歌詞。

邊界值: 5000
modelstring
選填

已上傳來源音訊的模型標識符。

允許值: suno-v4, suno-v4.5, suno-v4.5-all, suno-v4.5-plus, suno-v5, suno-v5.5
negative_tagsstring
選填

需要避免的風格。

tagsstring
必填

風格或流派標籤。

邊界值: 1000
task_idstring
選填

來源任務 ID。與 audio_id 搭配使用;不要與 upload_url/model 組合使用。

titlestring
必填

歌曲標題。

邊界值: 80
upload_urlstring
選填

已上傳的來源音訊 URL。與模型一同使用;請勿與 task_id/audio_id 結合使用。

04

建立接受

HTTP 202

POST /api/v1/suno/replace_section

回應結構
JSON
{
  "properties": {
    "billing": {
      "properties": {
        "refund": {
          "oneOf": [
            {
              "properties": {
                "refunded_at": {
                  "type": "string"
                }
              },
              "required": [
                "refunded_at"
              ],
              "type": "object",
              "unevaluatedProperties": false
            },
            {
              "enum": [
                null
              ]
            }
          ]
        },
        "reservation": {
          "oneOf": [
            {
              "properties": {
                "amount_cents": {
                  "type": "integer"
                }
              },
              "required": [
                "amount_cents"
              ],
              "type": "object",
              "unevaluatedProperties": false
            },
            {
              "enum": [
                null
              ]
            }
          ]
        },
        "settlement": {
          "oneOf": [
            {
              "properties": {
                "amount_micro_cents": {
                  "type": "integer"
                },
                "charged_amount_cents": {
                  "type": "integer"
                }
              },
              "required": [
                "charged_amount_cents",
                "amount_micro_cents"
              ],
              "type": "object",
              "unevaluatedProperties": false
            },
            {
              "enum": [
                null
              ]
            }
          ]
        }
      },
      "required": [
        "reservation",
        "settlement",
        "refund"
      ],
      "type": "object",
      "unevaluatedProperties": false
    },
    "id": {
      "type": "string"
    },
    "status": {
      "enum": [
        "processing"
      ],
      "type": "string"
    },
    "task_replayed": {
      "type": "boolean"
    }
  },
  "required": [
    "id",
    "status",
    "billing"
  ],
  "type": "object",
  "unevaluatedProperties": false
}

回應範例

JSON
{
  "billing": {
    "refund": null,
    "reservation": null,
    "settlement": null
  },
  "id": "tsk_reference_demo",
  "status": "processing"
}
05

輪詢處理中

HTTP 200

GET /api/v1/suno/replace_section/:id

回應結構
JSON
{
  "properties": {
    "billing": {
      "properties": {
        "refund": {
          "oneOf": [
            {
              "properties": {
                "refunded_at": {
                  "type": "string"
                }
              },
              "required": [
                "refunded_at"
              ],
              "type": "object",
              "unevaluatedProperties": false
            },
            {
              "enum": [
                null
              ]
            }
          ]
        },
        "reservation": {
          "oneOf": [
            {
              "properties": {
                "amount_cents": {
                  "type": "integer"
                }
              },
              "required": [
                "amount_cents"
              ],
              "type": "object",
              "unevaluatedProperties": false
            },
            {
              "enum": [
                null
              ]
            }
          ]
        },
        "settlement": {
          "oneOf": [
            {
              "properties": {
                "amount_micro_cents": {
                  "type": "integer"
                },
                "charged_amount_cents": {
                  "type": "integer"
                }
              },
              "required": [
                "charged_amount_cents",
                "amount_micro_cents"
              ],
              "type": "object",
              "unevaluatedProperties": false
            },
            {
              "enum": [
                null
              ]
            }
          ]
        }
      },
      "required": [
        "reservation",
        "settlement",
        "refund"
      ],
      "type": "object",
      "unevaluatedProperties": false
    },
    "id": {
      "type": "string"
    },
    "status": {
      "enum": [
        "processing"
      ],
      "type": "string"
    },
    "track": {
      "properties": {
        "audio_url": {
          "type": "string",
          "x-runapi-generated-media": true
        },
        "duration": {
          "type": "number"
        },
        "id": {
          "type": "string"
        },
        "image_url": {
          "type": "string",
          "x-runapi-generated-media": true
        },
        "lyrics": {
          "type": "string"
        },
        "model_name": {
          "type": "string"
        },
        "stream_audio_url": {
          "type": "string",
          "x-runapi-generated-media": true
        },
        "tags": {
          "items": {
            "type": "string"
          },
          "type": "array"
        },
        "title": {
          "type": "string"
        }
      },
      "required": [
        "id"
      ],
      "type": "object",
      "unevaluatedProperties": false
    }
  },
  "required": [
    "id",
    "status",
    "billing"
  ],
  "type": "object",
  "unevaluatedProperties": false
}

回應範例

JSON
{
  "billing": {
    "refund": null,
    "reservation": null,
    "settlement": null
  },
  "id": "tsk_reference_demo",
  "status": "processing"
}
06

輪詢已完成

HTTP 200

GET /api/v1/suno/replace_section/:id

回應結構
JSON
{
  "properties": {
    "billing": {
      "properties": {
        "refund": {
          "oneOf": [
            {
              "properties": {
                "refunded_at": {
                  "type": "string"
                }
              },
              "required": [
                "refunded_at"
              ],
              "type": "object",
              "unevaluatedProperties": false
            },
            {
              "enum": [
                null
              ]
            }
          ]
        },
        "reservation": {
          "oneOf": [
            {
              "properties": {
                "amount_cents": {
                  "type": "integer"
                }
              },
              "required": [
                "amount_cents"
              ],
              "type": "object",
              "unevaluatedProperties": false
            },
            {
              "enum": [
                null
              ]
            }
          ]
        },
        "settlement": {
          "oneOf": [
            {
              "properties": {
                "amount_micro_cents": {
                  "type": "integer"
                },
                "charged_amount_cents": {
                  "type": "integer"
                }
              },
              "required": [
                "charged_amount_cents",
                "amount_micro_cents"
              ],
              "type": "object",
              "unevaluatedProperties": false
            },
            {
              "enum": [
                null
              ]
            }
          ]
        }
      },
      "required": [
        "reservation",
        "settlement",
        "refund"
      ],
      "type": "object",
      "unevaluatedProperties": false
    },
    "id": {
      "type": "string"
    },
    "status": {
      "enum": [
        "completed"
      ],
      "type": "string"
    },
    "track": {
      "properties": {
        "audio_url": {
          "type": "string",
          "x-runapi-generated-media": true
        },
        "duration": {
          "type": "number"
        },
        "id": {
          "type": "string"
        },
        "image_url": {
          "type": "string",
          "x-runapi-generated-media": true
        },
        "lyrics": {
          "type": "string"
        },
        "model_name": {
          "type": "string"
        },
        "stream_audio_url": {
          "type": "string",
          "x-runapi-generated-media": true
        },
        "tags": {
          "items": {
            "type": "string"
          },
          "type": "array"
        },
        "title": {
          "type": "string"
        }
      },
      "required": [
        "id"
      ],
      "type": "object",
      "unevaluatedProperties": false
    }
  },
  "required": [
    "id",
    "status",
    "track",
    "billing"
  ],
  "type": "object",
  "unevaluatedProperties": false
}

回應範例

JSON
{
  "billing": {
    "refund": null,
    "reservation": null,
    "settlement": null
  },
  "id": "tsk_reference_demo",
  "status": "completed",
  "track": {
    "audio_url": "https://file.runapi.ai/reference-audio.mp3",
    "id": "audio_replaced_section"
  }
}
07

輪詢失敗

HTTP 200

GET /api/v1/suno/replace_section/:id

回應結構
JSON
{
  "properties": {
    "billing": {
      "properties": {
        "refund": {
          "oneOf": [
            {
              "properties": {
                "refunded_at": {
                  "type": "string"
                }
              },
              "required": [
                "refunded_at"
              ],
              "type": "object",
              "unevaluatedProperties": false
            },
            {
              "enum": [
                null
              ]
            }
          ]
        },
        "reservation": {
          "oneOf": [
            {
              "properties": {
                "amount_cents": {
                  "type": "integer"
                }
              },
              "required": [
                "amount_cents"
              ],
              "type": "object",
              "unevaluatedProperties": false
            },
            {
              "enum": [
                null
              ]
            }
          ]
        },
        "settlement": {
          "oneOf": [
            {
              "properties": {
                "amount_micro_cents": {
                  "type": "integer"
                },
                "charged_amount_cents": {
                  "type": "integer"
                }
              },
              "required": [
                "charged_amount_cents",
                "amount_micro_cents"
              ],
              "type": "object",
              "unevaluatedProperties": false
            },
            {
              "enum": [
                null
              ]
            }
          ]
        }
      },
      "required": [
        "reservation",
        "settlement",
        "refund"
      ],
      "type": "object",
      "unevaluatedProperties": false
    },
    "error": {
      "type": "string"
    },
    "id": {
      "type": "string"
    },
    "status": {
      "enum": [
        "failed"
      ],
      "type": "string"
    }
  },
  "required": [
    "id",
    "status",
    "error",
    "billing"
  ],
  "type": "object",
  "unevaluatedProperties": false
}

回應範例

JSON
{
  "billing": {
    "refund": null,
    "reservation": null,
    "settlement": null
  },
  "error": "Task processing failed.",
  "id": "tsk_reference_demo",
  "status": "failed"
}
08

客戶回呼:已完成

HTTP 200

POST callback_url

回應結構
JSON
{
  "properties": {
    "id": {
      "type": "string"
    },
    "status": {
      "enum": [
        "completed"
      ],
      "type": "string"
    },
    "track": {
      "properties": {
        "audio_url": {
          "type": "string",
          "x-runapi-generated-media": true
        },
        "duration": {
          "type": "number"
        },
        "id": {
          "type": "string"
        },
        "image_url": {
          "type": "string",
          "x-runapi-generated-media": true
        },
        "lyrics": {
          "type": "string"
        },
        "model_name": {
          "type": "string"
        },
        "stream_audio_url": {
          "type": "string",
          "x-runapi-generated-media": true
        },
        "tags": {
          "items": {
            "type": "string"
          },
          "type": "array"
        },
        "title": {
          "type": "string"
        }
      },
      "required": [
        "id"
      ],
      "type": "object",
      "unevaluatedProperties": false
    }
  },
  "required": [
    "id",
    "status",
    "track"
  ],
  "type": "object",
  "unevaluatedProperties": false
}

回應範例

JSON
{
  "id": "tsk_reference_demo",
  "status": "completed",
  "track": {
    "audio_url": "https://file.runapi.ai/reference-audio.mp3",
    "id": "audio_replaced_section"
  }
}
09

客戶回呼:已失敗

HTTP 200

POST callback_url

回應結構
JSON
{
  "properties": {
    "error": {
      "oneOf": [
        {
          "type": "string"
        },
        {
          "properties": {
            "code": {
              "type": "string"
            },
            "limit_cents": {
              "type": "integer"
            },
            "message": {
              "type": "string"
            },
            "reset_at": {
              "format": "date-time",
              "type": [
                "string",
                "null"
              ]
            },
            "used_cents": {
              "type": "integer"
            },
            "window": {
              "enum": [
                "1h",
                "1d",
                "7d",
                "daily",
                "weekly",
                "monthly",
                "lifetime"
              ],
              "type": "string"
            }
          },
          "required": [
            "code",
            "message"
          ],
          "type": "object",
          "unevaluatedProperties": false
        }
      ]
    },
    "id": {
      "type": "string"
    },
    "status": {
      "enum": [
        "failed"
      ],
      "type": "string"
    }
  },
  "required": [
    "id",
    "status",
    "error"
  ],
  "type": "object",
  "unevaluatedProperties": false
}

回應範例

JSON
{
  "error": {
    "code": "generation_failed",
    "message": "Task processing failed."
  },
  "id": "tsk_reference_demo",
  "status": "failed"
}
10

錯誤

HTTP 401

POST /api/v1/suno/replace_section

回應結構
JSON
{
  "properties": {
    "error": {
      "description": "人類可讀的錯誤訊息。",
      "type": "string"
    }
  },
  "required": [
    "error"
  ],
  "type": "object",
  "unevaluatedProperties": false
}

回應範例

JSON
{
  "error": "Authentication required"
}
11

錯誤

HTTP 401

GET /api/v1/suno/replace_section/:id

回應結構
JSON
{
  "properties": {
    "error": {
      "description": "人類可讀的錯誤訊息。",
      "type": "string"
    }
  },
  "required": [
    "error"
  ],
  "type": "object",
  "unevaluatedProperties": false
}

回應範例

JSON
{
  "error": "Authentication required"
}
12

錯誤

HTTP 400

POST /api/v1/suno/replace_section

回應結構
JSON
{
  "oneOf": [
    {
      "properties": {
        "error": {
          "description": "人類可讀的錯誤訊息。",
          "type": "string"
        }
      },
      "required": [
        "error"
      ],
      "type": "object",
      "unevaluatedProperties": false
    },
    {
      "properties": {
        "error": {
          "description": "人類可讀的驗證摘要。",
          "type": "string"
        },
        "errors": {
          "additionalProperties": {
            "items": {
              "type": "string"
            },
            "type": "array"
          },
          "description": "以公開請求欄位為鍵的驗證訊息,每個欄位對應一組人類可讀的字串陣列。",
          "type": "object"
        }
      },
      "required": [
        "error",
        "errors"
      ],
      "type": "object",
      "unevaluatedProperties": false
    }
  ]
}

回應範例

JSON
{
  "error": "model must be one of: "
}
13

錯誤

HTTP 402

POST /api/v1/suno/replace_section

回應結構
JSON
{
  "properties": {
    "error": {
      "description": "人類可讀的錯誤訊息。",
      "type": "string"
    }
  },
  "required": [
    "error"
  ],
  "type": "object",
  "unevaluatedProperties": false
}

回應範例

JSON
{
  "error": "Insufficient balance"
}
14

錯誤

HTTP 429

POST /api/v1/suno/replace_section

回應結構
JSON
{
  "properties": {
    "error": {
      "description": "人類可讀的錯誤訊息。",
      "type": "string"
    }
  },
  "required": [
    "error"
  ],
  "type": "object",
  "unevaluatedProperties": false
}

回應範例

JSON
{
  "error": "API key credit limit exceeded"
}
15

錯誤

HTTP 409

POST /api/v1/suno/replace_section

回應結構
JSON
{
  "properties": {
    "error": {
      "description": "人類可讀的錯誤訊息。",
      "type": "string"
    }
  },
  "required": [
    "error"
  ],
  "type": "object",
  "unevaluatedProperties": false
}

回應範例

JSON
{
  "error": "The request uses features that are not supported for the selected model"
}
16

錯誤

HTTP 429

POST /api/v1/suno/replace_section

回應結構
JSON
{
  "properties": {
    "error": {
      "description": "人類可讀的錯誤訊息。",
      "type": "string"
    }
  },
  "required": [
    "error"
  ],
  "type": "object",
  "unevaluatedProperties": false
}

回應範例

JSON
{
  "error": "Rate limit reached. Please retry later."
}
17

錯誤

HTTP 503

POST /api/v1/suno/replace_section

回應結構
JSON
{
  "properties": {
    "error": {
      "description": "人類可讀的錯誤訊息。",
      "type": "string"
    }
  },
  "required": [
    "error"
  ],
  "type": "object",
  "unevaluatedProperties": false
}

回應範例

JSON
{
  "error": "Service under maintenance, please try again later"
}
18

錯誤

HTTP 504

POST /api/v1/suno/replace_section

回應結構
JSON
{
  "properties": {
    "error": {
      "description": "人類可讀的錯誤訊息。",
      "type": "string"
    }
  },
  "required": [
    "error"
  ],
  "type": "object",
  "unevaluatedProperties": false
}

回應範例

JSON
{
  "error": "The request timed out"
}
19

錯誤

HTTP 404

GET /api/v1/suno/replace_section/:id

回應結構
JSON
{
  "properties": {
    "error": {
      "description": "人類可讀的錯誤訊息。",
      "type": "string"
    }
  },
  "required": [
    "error"
  ],
  "type": "object",
  "unevaluatedProperties": false
}

回應範例

JSON
{
  "error": "Task with id 'tsk_reference_demo' not found"
}
20

已生成的程式碼範例

直接使用 cURL,或為您的語言安裝 SDK。每個範例均提交本參考中所示的已驗證請求。

安裝

Shell
pip install runapi-suno
PYTHON
import os
from runapi.suno import SunoClient

client = SunoClient(api_key=os.environ["RUNAPI_API_KEY"])
task = client.replace_section.create(
  upload_url="https://file.runapi.ai/source-audio.mp3",
  model="suno-v5",
  lyrics="New words for this section.",
  tags="acoustic pop",
  title="City Lights",
  infill_start_time=10,
  infill_end_time=20,
  full_lyrics="City lights reflect in the rain. New words for this section."
)